

void move_arrows_startup()
{	
	VECTOR marker_pos;
	ANGLE marker_ang;
	ENTITY* selection;
}

STRING* tra = "A";

MATERIAL* mat_for_str(STRING* name)
{
	MATERIAL* temp_mat = *((MATERIAL**)engine_getvar(name,0));
	return(temp_mat);
}

var select_light_red;
var select_light_green;
var select_light_blue;

void clip_name(STRING* str, var num)
{
	STRING* temp_str = str_create("#30");
	if(str_len(str)>num)
	{
		str_clip(str,str_len(str)-num+3);
		str_cpy(temp_str,str);
		str_cpy(str,"...");
		str_cat(str,temp_str);
	}
}


void ent_select()
{
	selected.material = mat_for_str("mat_select");
	selected.flags2 |= UNTOUCHABLE; 
	
	str_cpy(selection_name,"");
	if(selected.obj_type==light_source)
	{
	pan_select(light_properties);
	select_light_red = selected.red;
   select_light_green = selected.green;
   select_light_blue = selected.blue;
   str_for_num((enter_light.pstring)[0],selected.lightrange);
   }
	
	if(selected.obj_type==level_entity)
	{
	pan_select(properties);
   str_cpy(selection_name,LevelObjects[selected.obj_num].model);
   str_cpy(selection_action,LevelObjects[selected.obj_num]._action);
   str_cpy(selection_material,LevelObjects[selected.obj_num]._material);
   
   //check flags
   button_state(ent_flags,0,0);
   button_state(ent_flags,1,0);
   button_state(ent_flags,2,0);
   button_state(ent_flags,3,0);
   button_state(ent_flags,4,0);
   button_state(ent_flags,5,0);
   button_state(ent_flags,6,0);
   button_state(ent_flags,7,0);
   button_state(ent_flags,8,0);
   button_state(ent_flags,9,0);
   button_state(ent_flags,10,0);
   button_state(ent_flags,11,0);
   button_state(ent_flags,12,0);
   button_state(ent_flags,13,0);
   button_state(ent_flags,14,0);
   button_state(ent_flags,15,0);
   button_state(ent_flags,16,0);
   button_state(ent_flags,17,0);
   
   if is(selected,PASSABLE)
   {
   button_state(ent_flags,0,1);
   }
   if is(selected,SHADOW)
   {
   button_state(ent_flags,1,1);
   }
   if is(selected,INVISIBLE)
   {
   button_state(ent_flags,2,1);
   }
   if is(selected,BRIGHT)
   {
   button_state(ent_flags,3,1);
   }
   if is(selected,OVERLAY)
   {
   button_state(ent_flags,4,1);
   }
   if is(selected,POLYGON)
   {
   button_state(ent_flags,5,1);
   }
   if is(selected,CAST)
   {
   button_state(ent_flags,6,1);
   }
   if is(selected,UNLIT)
   {
   button_state(ent_flags,7,1);
   }
   if is(selected,TRANSLUCENT)
   {
   button_state(ent_flags,8,1);
   }
   if is(selected,ZNEAR)
   {
   button_state(ent_flags,9,1);
   }
   if is(selected,FLAG1)
   {
   button_state(ent_flags,10,1);
   }
   if is(selected,FLAG2)
   {
   button_state(ent_flags,11,1);
   }
   if is(selected,FLAG3)
   {
   button_state(ent_flags,12,1);
   }
   if is(selected,FLAG4)
   {
   button_state(ent_flags,13,1);
   }
   if is(selected,FLAG5)
   {
   button_state(ent_flags,14,1);
   }
   if is(selected,FLAG6)
   {
   button_state(ent_flags,15,1);
   }
   if is(selected,FLAG7)
   {
   button_state(ent_flags,16,1);
   }
   if is(selected,FLAG8)
   {
   button_state(ent_flags,17,1);
   }
   
   
   str_for_num(obj_alpha,selected.alpha);
   str_for_num(obj_ambient,selected.ambient);
   str_for_num(obj_albedo,selected.albedo);
   
   str_for_num(obj_skill1,selected.skill1);
   str_for_num(obj_skill2,selected.skill2);
   str_for_num(obj_skill3,selected.skill3);
   str_for_num(obj_skill4,selected.skill4);
   str_for_num(obj_skill5,selected.skill5);
   str_for_num(obj_skill6,selected.skill6);
   str_for_num(obj_skill7,selected.skill7);
   str_for_num(obj_skill8,selected.skill8);
   str_for_num(obj_skill9,selected.skill9);
   str_for_num(obj_skill10,selected.skill10);
   }
   
   if(selected.obj_type==sound_source)
	{
		str_for_num((enter_vol.pstring)[0],selected.entsnd_volume);
		str_cpy(selection_name,sounds[selected.obj_num].file);
		clip_name(selection_name,25);
		pan_select(sound_properties);
	}
	while(selected)
	{
		proc_mode = PROC_LATE;
		
	if(!mouse_left){draw_bounding_box(selected);    }
		wait(1);
	}
}

void ent_deselect()
{
if(selected)
{
	if(selected.obj_type==light_source)
	{
	selected.material = mat_light;
   }
   if(selected.obj_type==sound_source)
	{
	selected.material = mat_model;
   }
   if(selected.obj_type==level_entity)
	{
	selected.material = mat_model;
   }
   selected.flags2 &= ~UNTOUCHABLE;

}
selected = NULL;
reset(properties,VISIBLE);
reset(light_properties,VISIBLE);
reset(sound_properties,VISIBLE);
}

var move_mul = 10;

void select()
{
   if(is(light_properties,VISIBLE)&&mouse_pos.x>light_properties.pos_x&&
   mouse_pos.x<light_properties.pos_x+bmap_width(light_properties.bmap)
   &&mouse_pos.y>light_properties.pos_y&&
   mouse_pos.y<light_properties.pos_y+bmap_height(light_properties.bmap)
   ){return;}
   var test;
   
   
   test = select_light_red+select_light_green+select_light_blue;
      panelgrab = 0;

   wait(1);
   if(select_light_red+select_light_green+select_light_blue!=test){return;}
	
   hide_menu();
   wait(1);
   if(in_menu||panelgrab||button_pressed){return;}	
	
	
   
   
  
   
   if(is(prefrences,VISIBLE)){return;}
   if(is(save_file,VISIBLE)){return;}
   if(is(open_file,VISIBLE)){return;}
   if(is(input_vec,VISIBLE)){return;}
   if(is(input_text,VISIBLE)){return;}
   if(is(fog_properties,VISIBLE)){return;}
   if(is(ent_flags,VISIBLE)){return;}
   if(is(ent_skills,VISIBLE)){return;}
   if(is(lighting_properties,VISIBLE)){return;}
  
	if(mouse_ent)
	{
	switch(mouse_ent.obj_type)
	{
	case z_drag_arrow:
		while(mouse_left)
		{
			ent_drag = 1;
			VECTOR move_dist;
			z_arrow.skin = 2;
			if(key_f)
			{
			if(selected.obj_type==level_entity)
			{
			unsnapped_sca[0]+=1*obj_scale_speed*mouse_force.y*time_step;
			if(scale_snap>0)
			{
			if(abs(unsnapped_sca[0])>1/scale_snap)
         {
            if(unsnapped_sca[0]>0){selected.scale_z+=1/scale_snap;}
            else{selected.scale_z-=1/scale_snap;}
            unsnapped_sca[0]=0;
         }
         }
         else
         {
         	selected.scale_z += unsnapped_sca[0];
            unsnapped_sca[0]=0;
         }
         }
			}
			else
			{
			if(key_r)
			{
		   unsnapped_ang[0]+=move_mul*obj_rotate_speed*mouse_force.x*time_step;
			if(rotate_snap)
			{
			if(abs(unsnapped_ang[0])>rotate_snap)
         {
            if(unsnapped_ang[0]>0){selected.pan+=rotate_snap;}
            else{selected.pan-=rotate_snap;}
            unsnapped_ang[0]=0;
         }
         }
         else
         {
         	selected.pan += unsnapped_ang[0];
            unsnapped_ang[0]=0;
         }
			}
			else
			{
			vec_set(move_dist,vector(0,0,move_mul*obj_move_speed*mouse_force.y*time_step));
			vec_rotate(move_dist,camera.pan);
			unsnapped_pos[0]+=move_dist.z;
			if(move_snap)
			{
			if(abs(unsnapped_pos[0])>move_snap)
         {
            if(unsnapped_pos[0]>0){selected.z+=move_snap;}
            else{selected.z-=move_snap;}
            if(mouse_right)
            {
            if(unsnapped_pos[0]>0){camera.z+=move_snap;}
            else{camera.z-=move_snap;}
            }
            unsnapped_pos[0]=0;
         }
         }
         else
         {
         	selected.z += unsnapped_pos[0];
         	if(mouse_right){camera.z += unsnapped_pos[0];}
            unsnapped_pos[0]=0;
         }
         vec_set(x_arrow.x,selected.x);
    x_arrow.x+=10;
    vec_set(y_arrow.x,selected.x);
    y_arrow.y+=10;
    vec_set(z_arrow.x,selected.x);
    z_arrow.z+=10;
    
		   }
		   }
		   draw_bounding_box(selected);
			wait(1);
		
	   }
	   ent_drag = 0;
	   z_arrow.skin = 1;
		vec_set(unsnapped_ang,nullvector);
      vec_set(unsnapped_sca,nullvector);
		return;
	break;
	
	case y_drag_arrow:
		while(mouse_left)
		{
			ent_drag = 1;
			VECTOR move_dist;
			y_arrow.skin = 2;
			if(key_f)
			{
			if(selected.obj_type==level_entity)
			{
			vec_set(move_dist,vector(move_mul*obj_move_speed*mouse_force.x*time_step,move_mul*obj_move_speed*mouse_force.x*time_step,move_mul*obj_move_speed*mouse_force.x*time_step));
			vec_rotate(move_dist,camera.pan);
			unsnapped_sca[1]-=move_dist.y;
			if(scale_snap>0)
			{
			if(abs(unsnapped_sca[1])>1/scale_snap)
         {
            if(unsnapped_sca[1]>0){selected.scale_y+=1/scale_snap;}
            else{selected.scale_y-=1/scale_snap;}
            unsnapped_sca[1]=0;
         }
         }
         else
         {
         	selected.scale_y += unsnapped_sca[1];
            unsnapped_sca[1]=0;
         }
			}
		   }
			else
			{
			if(key_r)
			{
		   vec_set(move_dist,vector(move_mul*obj_rotate_speed*mouse_force.x*time_step,move_mul*obj_rotate_speed*mouse_force.y*time_step,0));
			vec_rotate(move_dist,camera.pan);
		   unsnapped_ang[1]+=move_dist.y;
			if(rotate_snap)
			{
			if(abs(unsnapped_ang[1])>rotate_snap)
         {
            if(unsnapped_ang[1]>0){selected.tilt+=rotate_snap;}
            else{selected.tilt-=rotate_snap;}
            unsnapped_ang[1]=0;
         }
         }
         else
         {
         	selected.tilt += unsnapped_ang[1];
            unsnapped_ang[1]=0;
         }
			}
			else
			{
			vec_set(move_dist,vector(move_mul*obj_move_speed*mouse_force.x*time_step,move_mul*obj_move_speed*mouse_force.x*time_step,move_mul*obj_move_speed*mouse_force.x*time_step));
			vec_rotate(move_dist,camera.pan);
			unsnapped_pos[1]-=move_dist.y;
			if(move_snap)
			{
			if(abs(unsnapped_pos[1])>move_snap)
         {
            if(unsnapped_pos[1]>0){selected.y+=move_snap;}
            else{selected.y-=move_snap;}
            if(mouse_right)
            {
            if(unsnapped_pos[1]>0){camera.y+=move_snap;}
            else{camera.y-=move_snap;}
            }
            unsnapped_pos[1]=0;
         }
         }
         else
         {
         	selected.y += unsnapped_pos[1];
         	if(mouse_right){camera.y += unsnapped_pos[1];}
            unsnapped_pos[1]=0;
         }
         vec_set(x_arrow.x,selected.x);
    x_arrow.x+=10;
    vec_set(y_arrow.x,selected.x);
    y_arrow.y+=10;
    vec_set(z_arrow.x,selected.x);
    z_arrow.z+=10;
		   }
	      }
	      draw_bounding_box(selected);
			wait(1);
		}
		y_arrow.skin = 1;
		ent_drag = 0;
		return;
	break;
	
	case x_drag_arrow:
		while(mouse_left)
		{
			ent_drag = 1;
			VECTOR move_dist;
			x_arrow.skin = 2;
			if(key_f)
			{
			if(selected.obj_type==level_entity)
			{
			vec_set(move_dist,vector(move_mul*obj_scale_speed*mouse_force.x*time_step,move_mul*obj_scale_speed*mouse_force.y*time_step,0));
			vec_rotate(move_dist,camera.pan);
		   unsnapped_sca[2]+=move_dist.y;
			if(scale_snap>0)
			{
			if(abs(unsnapped_sca[2])>1/scale_snap)
         {
            if(unsnapped_sca[2]>0){selected.scale_x+=1/scale_snap;}
            else{selected.scale_x-=1/scale_snap;}
            unsnapped_sca[2]=0;
         }
         }
         else
         {
         	selected.scale_x += unsnapped_sca[2];
            unsnapped_sca[2]=0;
         }
			}
		   }
			else
			{
			if(key_r)
			{
			vec_set(move_dist,vector(move_mul*obj_rotate_speed*mouse_force.x*time_step,move_mul*obj_rotate_speed*mouse_force.x*time_step,move_mul*obj_rotate_speed*mouse_force.y*time_step));
			vec_rotate(move_dist,camera.pan);
		   unsnapped_ang[2]+=move_dist.z;
			if(rotate_snap)
			{
			if(abs(unsnapped_ang[2])>rotate_snap)
         {
            if(unsnapped_ang[2]>0){selected.roll+=rotate_snap;}
            else{selected.roll-=rotate_snap;}
            unsnapped_ang[2]=0;
         }
         }
         else
         {
         	selected.roll += unsnapped_ang[2];
            unsnapped_ang[2]=0;
         }
			}
			else
			{
			vec_set(move_dist,vector(move_mul*obj_move_speed*mouse_force.x*time_step,move_mul*obj_move_speed*mouse_force.y*time_step,0));
			vec_rotate(move_dist,camera.pan);
			unsnapped_pos[2]+=move_dist.y;
			if(move_snap)
			{
			if(abs(unsnapped_pos[2])>move_snap)
         {
            if(unsnapped_pos[2]>0){selected.x+=move_snap;}
            else{selected.x-=move_snap;}
            if(mouse_right)
            {
            if(unsnapped_pos[2]>0){camera.x+=move_snap;}
            else{camera.x-=move_snap;}
            }
            unsnapped_pos[2]=0;
         }
         }
         else
         {
         	selected.x += unsnapped_pos[2];
         	if(mouse_right){camera.x += unsnapped_pos[2];}
            unsnapped_pos[2]=0;
         }
         vec_set(x_arrow.x,selected.x);
    x_arrow.x+=10;
    vec_set(y_arrow.x,selected.x);
    y_arrow.y+=10;
    vec_set(z_arrow.x,selected.x);
    z_arrow.z+=10;
		   }
	      }
	      draw_bounding_box(selected);
			wait(1);
		}
		ent_drag = 0;
		x_arrow.skin = 1;
		return;
	break;
	
	default:
	mouse_ent.flags2 |= UNTOUCHABLE; 
   }
	
	if(selected)
	{
	ent_deselect();
   }
	selected = mouse_ent;
	ent_select();
	}
	
	else
	{
	if(selected)
	{
	ent_deselect();
   }
	selected = NULL;	
	}
	inkey_active = 0;
}